;file lib_dirbuf.inc

_lib_dirbuf_lowsize	equ	$013
_lib_dirbuf_lowhalf		macro
		org	code
	begin	=	$
expand
	;access dirbuf
	;entry: w = port pin (highnib = port, lownib = pin)
access_dirbuf
		mov	vp_portpin,w		;save pin id
		mov	w,<>vp_portpin		;port (ra to re) in lownib
		or	w,#$F0
		mov	fsr,w			;portA_dirbuf to portE_dirbuf
		mov	w,vp_portpin		;pin number 0 to 7 in lownib
	;get pin mask
	;entry: w lownib = pin number 0-7
	;exit:  w = pin mask
pin_mask
		and	w,#$07
		add	pc,w
		retw	1		;pin0
		retw	2		;pin1
		retw	4		;pin2
		retw	8		;pin3
		retw	16		;pin4
		retw	32		;pin5
		retw	64		;pin6
		retw	128		;pin7
		retp
get_pin		jmp	_get_pin
clrb_dirbuf	jmp	_clrb_dirbuf
setb_dirbuf	jmp	_setb_dirbuf
noexpand
code		=	$
if _lib_dirbuf_lowsize > code - begin
  error P2W "_dirbuf_lowsize too large"
endif
if _lib_dirbuf_lowsize < code - begin
  error "_dirbuf_lowsize too small"
endif
endm

_lib_dirbuf_highsize	equ	$013
_lib_dirbuf_highhalf	macro
		org	code
	begin	=	$
expand
	;get pin state
	;entry: w = port pin (highnib = port, lownib = pin)
	;exit: Z if pin low, NZ if pin high
_get_pin
		call	access_dirbuf
		sub	fsr,#portA_dirbuf-5	;ra to re
		mov	w,indf			;read all pins
		xor	vp_portpin,w		;swap vp_portpin and w
		xor	w,vp_portpin
		xor	vp_portpin,w
		call	pin_mask		;get mask for pin
		and	vp_portpin,w		;Z if pin low, NZ if pin high
		jmp	vp_access
	;make dirbuf bit high
	;entry: w = port pin (highnib = port, lownib = pin)
_setb_dirbuf
		call	access_dirbuf
		or	indf,w			;set dirbuf bit
		jmp	vp_access
	;make dirbuf bit low
	;entry: w = port pin (highnib = port, lownib = pin)
_clrb_dirbuf
		call	access_dirbuf
		not	w			;invert mask
		and	indf,w			;clear dirbuf bit
vp_access
		mov	fsr,vp_bank
		retp
noexpand
code		=	$
if _lib_dirbuf_highsize > code - begin
  error P2W "_dirbuf_highsize too large"
endif
if _lib_dirbuf_highsize < code - begin
  error "_dirbuf_highsize too small"
endif
endm

;end of file lib_dirbuf.inc
