;file lib_parity.inc

_lib_parity_lowsize		equ	$001
_lib_parity_lowhalf		macro
			org	code
	begin	=	$
expand
even_parity		jmp	_even_parity
noexpand
code		=	$
if _lib_parity_lowsize > code - begin
  error P2W "_parity_lowsize too large"
endif
if _lib_parity_lowsize < code - begin
  error "_parity_lowsize too small"
endif
endm

_lib_parity_highsize	equ	$08
_lib_parity_highhalf	macro
			org	code
	begin	=	$
expand
	; calculate even parity for w
	; result in vp_portpin.0
	;---------------------------------------------------------------------------------
_even_parity
			mov	vp_portpin,w

	;calculation code by John Payson, as found on sxlist.com
	;This routine will leave the parity of vp_portpin in vp_portpin.0
	;while blenderizing most of the rest of vp_portpin

			mov	w,<>vp_portpin	; vp_portpin = abcdefgh
			xor	vp_portpin,w
			mov	w,>>vp_portpin
			xor	vp_portpin,w

	; at this point, the parity for half the bits
	; (a, b, e, and f) is in bit 2 of vp_portpin, and the
	; parity for the other half (bits c, d, g, and h)
	; is in bit 0 of vp_portpin.

			snb	vp_portpin.2	; if the parity of (a,b,e,f) is 0,
                        			; then the parity of (a,b,c,d,e,f,g,h)
                        			; is equal to the parity of (c,d,g,h)...
                        			; which is already in bit 0, so skip ahead.

			inc	vp_portpin	; otherwise, the parity of (a,b,e,f) is 1,
						; so the parity of (a,b,c,d,e,f,g,h) is
						; NOT equal to the parity of (c,d,g,h).
						; invert bit 0.

	; at this point, bit 0 contains the parity of
	; (a,b,c,d,e,f,g,h).

			retp
noexpand
code			=	$
if _lib_parity_highsize > code - begin
  error P2W "_parity_highsize too large"
endif
if _lib_parity_highsize < code - begin
  error "_parity_highsize too small"
endif
endm

;end of file lib_parity.inc
