;file lib_stack.inc

;stack buffer layout
;
; +----+----+
; |size| num|  size = number of databytes in stack buffer, num = number of values on stack 
; +----+----+
; | d a t a |
; | d a t a |

_lib_stack_var		macro	name, size
  tempsize = size+1
if ((data + tempsize - 1) & $F0) != (data & $F0)
error "stack buffer too large, crossing rambank boundary"
endif
ifndef vp_stack
vp_stack
endif
			org	data
expand
??name??		equ	$
stack_??name??_sizenum	ds	1
stack_??name??_buffer	ds	size
noexpand
data		=	$
endm

lib_stack	macro	name, size
_lib_stack_var name,size
endm

_lib_stack_lowsize	equ	$002
_lib_stack_lowhalf	macro
		org	code
	begin	=	$
expand
push		jmp	_push
pop		jmp	_pop
noexpand
code		=	$
if _lib_stack_lowsize > code - begin
  error P2W "_stack_lowsize too large"
endif
if _lib_stack_lowsize < code - begin
  error "_stack_lowsize too small"
endif
endm

_lib_stack_highsize	equ	$018
_lib_stack_highhalf	macro
		org	code
	begin	=	$
expand
	;push value
	;entry: value in main_temp
	;       fsr set to stack_var address
	;return: Z if stack full (and value not stored)
	;	 fsr destroyed
_push
		mov	w,<>indf	;load size+num
		xor	w,indf		;xor size with num
		snz
		retp			;stack full
		inc	indf		;inc num
		mov	w,indf		;get num in lownib
		and	w,#$0F
		inc	fsr		;point to stack begin
		add	fsr,w		;top of stack position
		mov	w,main_temp
		mov	indf,w		;store value
		retp
	;pop value
	;entry: fsr set to stack address
	;return: Z if stack empty (and no value returned)
	;        value in w
_pop
		mov	w,indf		;load size+num
		and	w,#$0F		;test num
		snz
		retp			;stack empty
		dec	indf		;dec num
		mov	w,indf		;get num in lownib
		and	w,#$0F
		inc	fsr		;point to stack begin
		add	fsr,w		;top of stack position
		mov	w,indf		;get value
		mov	main_temp,w
		retp
noexpand
code		=	$
if _lib_stack_highsize > code - begin
  error P2W "_stack_highsize too large"
endif
if _lib_stack_highsize < code - begin
  error "_stack_highsize too small"
endif
endm

;end of file lib_stack.inc
